{                BEST ATTAINABLE MATCH ALGORITHM
                          R.M.Fewster
              University of St. Andrews, Scotland, UK.

                           bamprelim.p
                           -----------     
Pre-processing of data for binary maps.  This program should be
compiled and run BEFORE the main program bam.p.   This program is free
and comes with no guarantees.

The clique structure is read in from the file cliquesfile.

Map data is read in from file preliminfile, and the number of
mismatched 0's and 1's and the set of swappable sites is determined for
each mismatched site.  Outputs are written to the files mismatch0,
mismatch1, opmismatch, Nmismfile.

Edit the code at point marked *EDIT* to set the number of sites in the
map.} 


program bampreliminaries(preliminfile,cliquesfile, mismatch0, mismatch1,
opmismatch, Nmismfile);

const N=2500;  {*EDIT*: total number of sites in each of the 2 maps}

type
   siterange = 1..N;
   cliquesets = set of siterange;
   cliquearray = array[siterange] of cliquesets;
   

var clique, opmism : cliquearray;
          {clique holds the clique structure; 
           opmism holds the opposite mismatches for each mismatched site}

    mismsiteno : cliquesets;  {the site numbers of the mismatched sites}
    sitemismno : array[1..N] of integer;  {the mismatch number for each site
                                           (-1 if site is a match) }
             
    dist : array[1..2,1..N] of integer;  {distributions to be compared}

    preliminfile, cliquesfile : text;
    mismatch1, mismatch0, opmismatch, Nmismfile : text;

    t, i, Nmism, Nmism1, Nmism0, z, cst, j : integer;
   {mismatched 0's are mismatches that have 0 in dist[2,.];
    mismatched 1's are mismatches with 1 in dist[2,.]}
    
    Nmatch0, Nmatch1, x, y : integer;

begin

{---------- read in clique structure from cliquesfile -------------}
    reset(cliquesfile);
    for z:=1 to N do begin
      clique[z]:=[];
      repeat
        read(cliquesfile, cst);
        if cst>-1 then clique[z]:=clique[z]+[cst];
      until cst=-1;
      readln(cliquesfile);
    end; {z}    


{---- find mismatches and corresponding opposite mismatches ----}
    reset(preliminfile);
    rewrite(mismatch0);
    rewrite(mismatch1);
    rewrite(opmismatch);
    Nmism0:=0; Nmism1:=0; Nmism:=0; mismsiteno:=[];
    Nmatch0:=0; Nmatch1:=0;

    for t:=1 to 2 do for i:=1 to N do read(preliminfile, dist[t,i]);
    
    for i:=1 to N do begin 
       if dist[1,i]<>dist[2,i] then begin
         Nmism:=Nmism+1;      {so this is the Nmism'th mismatched site}
         if dist[2,i]=0 then Nmism0:=Nmism0+1
         else Nmism1:=Nmism1+1;
         mismsiteno:=mismsiteno+[i];  {mismsiteno also contains the site 
                                     numbers of the mismatches}
         sitemismno[i]:=Nmism;   {the i'th site has mismatch number Nmism}
       end  {i a mismatch}
       else begin  {i not a mismatch}
         if dist[2,i]=0 then Nmatch0:=Nmatch0+1
         else Nmatch1:=Nmatch1+1;
         sitemismno[i]:=-1;
       end;  {i not a mismatch}
    end;  {i}       

    {so far... got the set of SITE NUMBERS of mismatched sites,     
    mismsiteno, and formed the array sitemismno containing the mismatch 
    number of each site}

    {next: need the mismatch numbers of mismatched 0's and mismatched 1's}

    for i:=1 to N do if i in mismsiteno then begin
                {site number i is a mismatch}
        if dist[2,i]=0 then writeln(mismatch0, sitemismno[i])
            {i.e. write the mismatch number of site number i to the file 
            mismatch0}
        else writeln(mismatch1, sitemismno[i]);
    
        {find the MISMATCH NUMBERS of the opposite mismatch sites to i
        and write them to the file opmismatch:}
    
        for j:=1 to N do 
           if (j in clique[i]) and (j in mismsiteno) and (dist[2,j]<>dist[2,i]) 
           then write(opmismatch, sitemismno[j]:7);
        write(opmismatch, '    -1'); writeln(opmismatch);

    end;  {i}
    rewrite(Nmismfile);
    writeln(Nmismfile, Nmism0:3);
    writeln(Nmismfile, Nmism1:3);
    writeln(Nmismfile, Nmatch0:3);
    writeln(Nmismfile, Nmatch1:3);

end.

